{
*************************************************
************** TDelEdit component****************
*************************************************
*      Copyright (c) 1999 by Karel Quast        * 
*                Quadrad Studios                *
*             component is FREEWARE             *
*************************************************
****************karel@kamarad.cz*****************
*************************************************
}


unit DelEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TNumLockStates=(tnsNone,tnsNumOn,tnsNumOff);
  TDelEdit = class(TEdit)
  private
    { Private declarations }
    FGroupIndex:Integer;
    FNS:TNumLockStates;
//    FOldNS:Byte;
  protected
    { Protected declarations }
    procedure SetGroupIndex(Value:Integer);
    procedure Refresh_it;
    procedure KeyPress(var Key: Char); override;
	 procedure CMEnter(var Message: TCMGotFocus); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
  public
    { Public declarations }
  published
    { Published declarations }
    property GroupIndex:Integer read FGroupIndex write SetGroupIndex default 0;
    property NumLock:TNumLockStates read FNS write FNS default tnsNone;
  end;

procedure Register;

implementation

procedure TDelEdit.KeyPress;
begin
	if Key<>#0 then Refresh_it;
end;

procedure TDelEdit.SetGroupIndex(Value:Integer);
begin
	FGroupIndex:=Value;
   Refresh_it;
end;

procedure TDelEdit.Refresh_it;
var
	i:Integer;
	Sibling: TDelEdit;
begin
	if FGroupIndex=0 then exit;
	if Parent <> nil then
		for i:=0 to Parent.ControlCount-1 do
			if Parent.Controls[i] is TDelEdit then begin
				Sibling:=TDelEdit(Parent.Controls[i]);
				if (Sibling<>Self) and (Sibling.GroupIndex=FGroupIndex) then
					Sibling.Text:='';
			end;
end;

procedure TDelEdit.CMEnter(var Message: TCMGotFocus);
var
	B:Byte;
begin
	if FNS=tnsNone then exit;
{   GetKeyboardState(State);
   FOldNS:=State[vk_NumLock];
   if FNS=tnsNumOn then State[vk_NumLock]:=1 else State[vk_NumLock]:=0;
   SetKeyBoardState(State);}
   if FNS=tnsNumOn then B:=2 else B:=0;
	asm
		mov al,0edh
      out 64h,al
      mov al,b
      out 64h,al
   end;
	inherited;
end;

procedure TDelEdit.CMExit(var Message: TCMExit);
//var B:Byte;
begin
{	State[vk_NumLock]:=FOldNS;
   SetKeyBoardState(State);}
   inherited;
end;

procedure Register;
begin
  RegisterComponents('Edity', [TDelEdit]);
end;

end.
